const Tag = ({ element: Element, props, children }) => {
    return (
        <Element {...props}>
            {children}
        </Element>
    );
};

const SelfClosingTag = ({ element: Element, props }) => {
    return <Element {...props} />;
};

const json_to_dom = ({ structure }) => {
    return structure.map((item, index) => {
        const { selfClosing, _props, name, element, children, ...props } = item;

        const TagType = typeof element === 'string' ? (selfClosing ? SelfClosingTag : Tag) : element;

        const tagParams = { element, props };

        if (!selfClosing && children) {
            if (Array.isArray(children)) {
                tagParams.children = json_to_dom({ structure: children });
            } else {
                tagParams.children = children;
            };
        };

        return <TagType key={index} {...tagParams} />;
    });
};

export default json_to_dom;